Index: drivers/filesystems/btrfs/treefuncs.c
===================================================================
--- drivers/filesystems/btrfs/treefuncs.c	(révision 75772)
+++ drivers/filesystems/btrfs/treefuncs.c	(copie de travail)
@@ -667,148 +689,149 @@
 
         return TRUE;
     }
-    
+
     if (!tp->tree->parent)
         return FALSE;
-    
+
     t = tp->tree;
     while (t && (!t->parent || !prev_item(t->parent, t->paritem))) {
         t = t->parent;
     }
-    
+
     if (!t)
         return FALSE;
-    
+
     td = prev_item(t->parent, t->paritem);
-    
-    Status = _do_load_tree(Vcb, &td->treeholder, t->parent->root, t->parent, td, &loaded, Irp, func, file, line);
+
+    Status = do_load_tree(Vcb, &td->treeholder, t->parent->root, t->parent, td, &loaded, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("do_load_tree returned %08x\n", Status);
         return FALSE;
     }
-    
+
     t = td->treeholder.tree;
-    
+
     while (t->header.level != 0) {
         tree_data* li;
-        
+
         li = last_item(t);
-        
-        Status = _do_load_tree(Vcb, &li->treeholder, t->parent->root, t, li, &loaded, Irp, func, file, line);
+
+        Status = do_load_tree(Vcb, &li->treeholder, t->parent->root, t, li, &loaded, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("do_load_tree returned %08x\n", Status);
             return FALSE;
         }
-        
+
         t = li->treeholder.tree;
     }
-    
+
     prev_tp->tree = t;
     prev_tp->item = last_item(t);
-    
+
     return TRUE;
 }
 
-// static void free_tree_holder(tree_holder* th) {
-//     root* r = th->tree->root;
-//     
-// //     ExAcquireResourceExclusiveLite(&th->nonpaged->lock, TRUE);
-//     ExAcquireResourceExclusiveLite(&r->nonpaged->load_tree_lock, TRUE);
-// 
-//     free_tree2(th->tree, funcname, __FILE__, __LINE__);
-// 
-// //     ExReleaseResourceLite(&th->nonpaged->lock);
-//     ExReleaseResourceLite(&r->nonpaged->load_tree_lock);
-// }
-
 void free_trees_root(device_extension* Vcb, root* r) {
     LIST_ENTRY* le;
-    UINT8 level;
-    
+    ULONG level;
+
     for (level = 0; level <= 255; level++) {
         BOOL empty = TRUE;
-        
+
         le = Vcb->trees.Flink;
-        
+
         while (le != &Vcb->trees) {
             LIST_ENTRY* nextle = le->Flink;
             tree* t = CONTAINING_RECORD(le, tree, list_entry);
-            
+
             if (t->root == r) {
                 if (t->header.level == level) {
                     BOOL top = !t->paritem;
-                    
+
                     empty = FALSE;
-                    
-                    free_tree2(t, funcname, __FILE__, __LINE__);
+
+                    free_tree2(t);
                     if (top && r->treeholder.tree == t)
                         r->treeholder.tree = NULL;
-                    
+
                     if (IsListEmpty(&Vcb->trees))
                         return;
                 } else if (t->header.level > level)
                     empty = FALSE;
             }
-            
+
             le = nextle;
         }
-        
+
         if (empty)
             break;
     }
 }
 
-void STDCALL free_trees(device_extension* Vcb) {
+void free_trees(device_extension* Vcb) {
     LIST_ENTRY* le;
-    UINT8 level;
-    
+    ULONG level;
+
     for (level = 0; level <= 255; level++) {
         BOOL empty = TRUE;
-        
+
         le = Vcb->trees.Flink;
-        
+
         while (le != &Vcb->trees) {
             LIST_ENTRY* nextle = le->Flink;
             tree* t = CONTAINING_RECORD(le, tree, list_entry);
             root* r = t->root;
-            
+
             if (t->header.level == level) {
                 BOOL top = !t->paritem;
-                
+
                 empty = FALSE;
-                
-                free_tree2(t, funcname, __FILE__, __LINE__);
+
+                free_tree2(t);
                 if (top && r->treeholder.tree == t)
                     r->treeholder.tree = NULL;
-                
+
                 if (IsListEmpty(&Vcb->trees))
                     return;
             } else if (t->header.level > level)
                 empty = FALSE;
-            
+
             le = nextle;
         }
-        
+
         if (empty)
             break;
     }
 }
 
-void add_rollback(device_extension* Vcb, LIST_ENTRY* rollback, enum rollback_type type, void* ptr) {
+#ifdef _MSC_VER
+#pragma warning(push)
+#pragma warning(suppress: 28194)
+#endif
+void add_rollback(_In_ LIST_ENTRY* rollback, _In_ enum rollback_type type, _In_ __drv_aliasesMem void* ptr) {
     rollback_item* ri;
-    
+
     ri = ExAllocatePoolWithTag(PagedPool, sizeof(rollback_item), ALLOC_TAG);
     if (!ri) {
         ERR("out of memory\n");
         return;
     }
-    
+
     ri->type = type;
     ri->ptr = ptr;
     InsertTailList(rollback, &ri->list_entry);
 }
+#ifdef _MSC_VER
+#pragma warning(pop)
+#endif
 
-BOOL STDCALL insert_tree_item(device_extension* Vcb, root* r, UINT64 obj_id, UINT8 obj_type, UINT64 offset, void* data, UINT32 size, traverse_ptr* ptp, PIRP Irp, LIST_ENTRY* rollback) {
+#ifdef _MSC_VER
+#pragma warning(push)
+#pragma warning(suppress: 28194)
+#endif
+NTSTATUS insert_tree_item(_In_ _Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_ root* r, _In_ UINT64 obj_id,
+                          _In_ UINT8 obj_type, _In_ UINT64 offset, _In_reads_bytes_opt_(size) _When_(return >= 0, __drv_aliasesMem) void* data,
+                          _In_ UINT16 size, _Out_opt_ traverse_ptr* ptp, _In_opt_ PIRP Irp) {
     traverse_ptr tp;
     KEY searchkey;
     int cmp;
@@ -818,79 +841,71 @@
     LIST_ENTRY* le;
     KEY firstitem = {0xcccccccccccccccc,0xcc,0xcccccccccccccccc};
 #endif
-    traverse_ptr* tp2;
-    BOOL success = FALSE;
     NTSTATUS Status;
-    
-    TRACE("(%p, %p, %llx, %x, %llx, %p, %x, %p, %p)\n", Vcb, r, obj_id, obj_type, offset, data, size, ptp, rollback);
-    
-// #ifdef DEBUG_PARANOID
-//     if (!ExIsResourceAcquiredExclusiveLite(&Vcb->tree_lock)) {
-//         ERR("ERROR - tree_lock not held exclusively\n");
-//         int3;
-//     }
-// #endif
-    
+
+    TRACE("(%p, %p, %llx, %x, %llx, %p, %x, %p)\n", Vcb, r, obj_id, obj_type, offset, data, size, ptp);
+
     searchkey.obj_id = obj_id;
     searchkey.obj_type = obj_type;
     searchkey.offset = offset;
-    
+
     Status = find_item(Vcb, r, &tp, &searchkey, TRUE, Irp);
     if (Status == STATUS_NOT_FOUND) {
         if (r) {
             if (!r->treeholder.tree) {
                 BOOL loaded;
-                
+
                 Status = do_load_tree(Vcb, &r->treeholder, r, NULL, NULL, &loaded, Irp);
-                
                 if (!NT_SUCCESS(Status)) {
                     ERR("do_load_tree returned %08x\n", Status);
-                    goto end;
+                    return Status;
                 }
             }
-            
+
             if (r->treeholder.tree && r->treeholder.tree->header.num_items == 0) {
                 tp.tree = r->treeholder.tree;
                 tp.item = NULL;
             } else {
                 ERR("error: unable to load tree for root %llx\n", r->id);
-                goto end;
+                return STATUS_INTERNAL_ERROR;
             }
         } else {
             ERR("error: find_item returned %08x\n", Status);
-            goto end;
+            return Status;
         }
     } else if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
-        goto end;
+        return Status;
     }
-    
+
     TRACE("tp.item = %p\n", tp.item);
-    
+
     if (tp.item) {
         TRACE("tp.item->key = %p\n", &tp.item->key);
         cmp = keycmp(searchkey, tp.item->key);
-        
-        if (cmp == 0 && !tp.item->ignore) { // FIXME - look for all items of the same key to make sure none are non-ignored
+
+        if (cmp == 0 && !tp.item->ignore) {
             ERR("error: key (%llx,%x,%llx) already present\n", obj_id, obj_type, offset);
+#ifdef DEBUG_PARANOID
             int3;
-            goto end;
+#endif
+            return STATUS_INTERNAL_ERROR;
         }
     } else
         cmp = -1;
-    
+
     td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
     if (!td) {
         ERR("out of memory\n");
-        goto end;
+        return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     td->key = searchkey;
     td->size = size;
     td->data = data;
     td->ignore = FALSE;
     td->inserted = TRUE;
-    
+
 #ifdef _DEBUG
     le = tp.tree->itemlist.Flink;
     while (le != &tp.tree->itemlist) {
@@ -898,21 +913,20 @@
         firstitem = td2->key;
         break;
     }
-    
+
     TRACE("inserting %llx,%x,%llx into tree beginning %llx,%x,%llx (num_items %x)\n", obj_id, obj_type, offset, firstitem.obj_id, firstitem.obj_type, firstitem.offset, tp.tree->header.num_items);
 #endif
-    
+
     if (cmp == -1) { // very first key in root
         InsertHeadList(&tp.tree->itemlist, &td->list_entry);
 
         paritem = tp.tree->paritem;
         while (paritem) {
-//             ERR("paritem = %llx,%x,%llx, tp.item->key = %llx,%x,%llx\n", paritem->key.obj_id, paritem->key.obj_type, paritem->key.offset, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
             if (!keycmp(paritem->key, tp.item->key)) {
                 paritem->key = searchkey;
             } else
                 break;
-            
+
             paritem = paritem->treeholder.tree->paritem;
         }
     } else if (cmp == 0)
@@ -919,20 +933,18 @@
         InsertHeadList(tp.item->list_entry.Blink, &td->list_entry); // make sure non-deleted item is before deleted ones
     else
         InsertHeadList(&tp.item->list_entry, &td->list_entry);
-    
+
     tp.tree->header.num_items++;
     tp.tree->size += size + sizeof(leaf_node);
-//     ERR("tree %p, num_items now %x\n", tp.tree, tp.tree->header.num_items);
-//     ERR("size now %x\n", tp.tree->size);
-    
+
     if (!tp.tree->write) {
         tp.tree->write = TRUE;
         Vcb->need_write = TRUE;
     }
-    
+
     if (ptp)
         *ptp = tp;
-    
+
     t = tp.tree;
     while (t) {
         if (t->paritem && t->paritem->ignore) {
@@ -939,114 +951,63 @@
             t->paritem->ignore = FALSE;
             t->parent->header.num_items++;
             t->parent->size += sizeof(internal_node);
-            
-            // FIXME - do we need to add a rollback entry here?
         }
 
         t->header.generation = Vcb->superblock.generation;
         t = t->parent;
     }
-    
-    // FIXME - free this correctly
-    
-    tp2 = ExAllocateFromPagedLookasideList(&Vcb->traverse_ptr_lookaside);
-    if (!tp2) {
-        ERR("out of memory\n");
-        goto end;
-    }
-    
-    tp2->tree = tp.tree;
-    tp2->item = td;
-    
-    add_rollback(Vcb, rollback, ROLLBACK_INSERT_ITEM, tp2);
-    
-    success = TRUE;
 
-end:
-    return success;
+    return STATUS_SUCCESS;
 }
+#ifdef _MSC_VER
+#pragma warning(pop)
+#endif
 
-static __inline tree_data* first_valid_item(tree* t) {
-    LIST_ENTRY* le = t->itemlist.Flink;
-    
-    while (le != &t->itemlist) {
-        tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-        
-        if (!td->ignore)
-            return td;
-        
-        le = le->Flink;
-    }
-        
-    return NULL;
-}
-
-void STDCALL delete_tree_item(device_extension* Vcb, traverse_ptr* tp, LIST_ENTRY* rollback) {
+NTSTATUS delete_tree_item(_In_ _Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _Inout_ traverse_ptr* tp) {
     tree* t;
     UINT64 gen;
-    traverse_ptr* tp2;
 
     TRACE("deleting item %llx,%x,%llx (ignore = %s)\n", tp->item->key.obj_id, tp->item->key.obj_type, tp->item->key.offset, tp->item->ignore ? "TRUE" : "FALSE");
-    
+
 #ifdef DEBUG_PARANOID
-//     if (!ExIsResourceAcquiredExclusiveLite(&Vcb->tree_lock)) {
-//         ERR("ERROR - tree_lock not held exclusively\n");
-//         int3;
-//     }
-
     if (tp->item->ignore) {
         ERR("trying to delete already-deleted item %llx,%x,%llx\n", tp->item->key.obj_id, tp->item->key.obj_type, tp->item->key.offset);
         int3;
+        return STATUS_INTERNAL_ERROR;
     }
 #endif
 
     tp->item->ignore = TRUE;
-    
+
     if (!tp->tree->write) {
         tp->tree->write = TRUE;
         Vcb->need_write = TRUE;
     }
-    
+
     tp->tree->header.num_items--;
-    
+
     if (tp->tree->header.level == 0)
         tp->tree->size -= sizeof(leaf_node) + tp->item->size;
     else
         tp->tree->size -= sizeof(internal_node);
-    
+
     gen = tp->tree->Vcb->superblock.generation;
-    
+
     t = tp->tree;
     while (t) {
         t->header.generation = gen;
         t = t->parent;
     }
-    
-    tp2 = ExAllocateFromPagedLookasideList(&Vcb->traverse_ptr_lookaside);
-    if (!tp2) {
-        ERR("out of memory\n");
-        return;
-    }
-    
-    tp2->tree = tp->tree;
-    tp2->item = tp->item;
 
-    add_rollback(Vcb, rollback, ROLLBACK_DELETE_ITEM, tp2);
+    return STATUS_SUCCESS;
 }
 
-void clear_rollback(device_extension* Vcb, LIST_ENTRY* rollback) {
-    rollback_item* ri;
-    
+void clear_rollback(LIST_ENTRY* rollback) {
     while (!IsListEmpty(rollback)) {
         LIST_ENTRY* le = RemoveHeadList(rollback);
-        ri = CONTAINING_RECORD(le, rollback_item, list_entry);
-        
+        rollback_item* ri = CONTAINING_RECORD(le, rollback_item, list_entry);
+
         switch (ri->type) {
-            case ROLLBACK_INSERT_ITEM:
-            case ROLLBACK_DELETE_ITEM:
-                ExFreeToPagedLookasideList(&Vcb->traverse_ptr_lookaside, ri->ptr);
-                break;
-                
             case ROLLBACK_ADD_SPACE:
             case ROLLBACK_SUBTRACT_SPACE:
             case ROLLBACK_INSERT_EXTENT:
@@ -1057,7 +1018,7 @@
             default:
                 break;
         }
-        
+
         ExFreePool(ri);
     }
 }
@@ -1065,102 +1026,66 @@
 void do_rollback(device_extension* Vcb, LIST_ENTRY* rollback) {
     NTSTATUS Status;
     rollback_item* ri;
-    
+
     while (!IsListEmpty(rollback)) {
         LIST_ENTRY* le = RemoveTailList(rollback);
         ri = CONTAINING_RECORD(le, rollback_item, list_entry);
-        
+
         switch (ri->type) {
-            case ROLLBACK_INSERT_ITEM:
-            {
-                traverse_ptr* tp = ri->ptr;
-                
-                if (!tp->item->ignore) {
-                    tp->item->ignore = TRUE;
-                    tp->tree->header.num_items--;
-                
-                    if (tp->tree->header.level == 0)
-                        tp->tree->size -= sizeof(leaf_node) + tp->item->size;
-                    else
-                        tp->tree->size -= sizeof(internal_node);
-                }
-                
-                ExFreeToPagedLookasideList(&Vcb->traverse_ptr_lookaside, tp);
-                break;
-            }
-                
-            case ROLLBACK_DELETE_ITEM:
-            {
-                traverse_ptr* tp = ri->ptr;
-                
-                if (tp->item->ignore) {
-                    tp->item->ignore = FALSE;
-                    tp->tree->header.num_items++;
-                
-                    if (tp->tree->header.level == 0)
-                        tp->tree->size += sizeof(leaf_node) + tp->item->size;
-                    else
-                        tp->tree->size += sizeof(internal_node);
-                }
-                
-                ExFreeToPagedLookasideList(&Vcb->traverse_ptr_lookaside, tp);
-                break;
-            }
-            
             case ROLLBACK_INSERT_EXTENT:
             {
                 rollback_extent* re = ri->ptr;
-                
+
                 re->ext->ignore = TRUE;
-                
-                if (re->ext->data->type == EXTENT_TYPE_REGULAR || re->ext->data->type == EXTENT_TYPE_PREALLOC) {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)re->ext->data->data;
-                    
+
+                if (re->ext->extent_data.type == EXTENT_TYPE_REGULAR || re->ext->extent_data.type == EXTENT_TYPE_PREALLOC) {
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)re->ext->extent_data.data;
+
                     if (ed2->size != 0) {
                         chunk* c = get_chunk_from_address(Vcb, ed2->address);
-                        
+
                         if (c) {
                             Status = update_changed_extent_ref(Vcb, c, ed2->address, ed2->size, re->fcb->subvol->id,
                                                                re->fcb->inode, re->ext->offset - ed2->offset, -1,
                                                                re->fcb->inode_item.flags & BTRFS_INODE_NODATASUM, FALSE, NULL);
-                            
+
                             if (!NT_SUCCESS(Status))
                                 ERR("update_changed_extent_ref returned %08x\n", Status);
                         }
-                        
+
                         re->fcb->inode_item.st_blocks -= ed2->num_bytes;
                     }
                 }
-                
+
                 ExFreePool(re);
                 break;
             }
-            
+
             case ROLLBACK_DELETE_EXTENT:
             {
                 rollback_extent* re = ri->ptr;
-                
+
                 re->ext->ignore = FALSE;
-                
-                if (re->ext->data->type == EXTENT_TYPE_REGULAR || re->ext->data->type == EXTENT_TYPE_PREALLOC) {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)re->ext->data->data;
-                    
+
+                if (re->ext->extent_data.type == EXTENT_TYPE_REGULAR || re->ext->extent_data.type == EXTENT_TYPE_PREALLOC) {
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)re->ext->extent_data.data;
+
                     if (ed2->size != 0) {
                         chunk* c = get_chunk_from_address(Vcb, ed2->address);
-                        
+
                         if (c) {
                             Status = update_changed_extent_ref(Vcb, c, ed2->address, ed2->size, re->fcb->subvol->id,
                                                                re->fcb->inode, re->ext->offset - ed2->offset, 1,
                                                                re->fcb->inode_item.flags & BTRFS_INODE_NODATASUM, FALSE, NULL);
-                            
+
                             if (!NT_SUCCESS(Status))
                                 ERR("update_changed_extent_ref returned %08x\n", Status);
                         }
-                        
+
                         re->fcb->inode_item.st_blocks += ed2->num_bytes;
                     }
                 }
-                
+
                 ExFreePool(re);
                 break;
             }
@@ -1169,49 +1094,59 @@
             case ROLLBACK_SUBTRACT_SPACE:
             {
                 rollback_space* rs = ri->ptr;
-                
+
                 if (rs->chunk)
                     ExAcquireResourceExclusiveLite(&rs->chunk->lock, TRUE);
-                
+
                 if (ri->type == ROLLBACK_ADD_SPACE)
-                    space_list_subtract2(Vcb, rs->list, rs->list_size, rs->address, rs->length, NULL);
+                    space_list_subtract2(rs->list, rs->list_size, rs->address, rs->length, NULL, NULL);
                 else
-                    space_list_add2(Vcb, rs->list, rs->list_size, rs->address, rs->length, NULL);
-                
+                    space_list_add2(rs->list, rs->list_size, rs->address, rs->length, NULL, NULL);
+
                 if (rs->chunk) {
+                    if (ri->type == ROLLBACK_ADD_SPACE)
+                        rs->chunk->used += rs->length;
+                    else
+                        rs->chunk->used -= rs->length;
+                }
+
+                if (rs->chunk) {
                     LIST_ENTRY* le2 = le->Blink;
-                    
+
                     while (le2 != rollback) {
                         LIST_ENTRY* le3 = le2->Blink;
                         rollback_item* ri2 = CONTAINING_RECORD(le2, rollback_item, list_entry);
-                        
+
                         if (ri2->type == ROLLBACK_ADD_SPACE || ri2->type == ROLLBACK_SUBTRACT_SPACE) {
                             rollback_space* rs2 = ri2->ptr;
-                            
+
                             if (rs2->chunk == rs->chunk) {
-                                if (ri2->type == ROLLBACK_ADD_SPACE)
-                                    space_list_subtract2(Vcb, rs2->list, rs2->list_size, rs2->address, rs2->length, NULL);
-                                else
-                                    space_list_add2(Vcb, rs2->list, rs2->list_size, rs2->address, rs2->length, NULL);
-                                
+                                if (ri2->type == ROLLBACK_ADD_SPACE) {
+                                    space_list_subtract2(rs2->list, rs2->list_size, rs2->address, rs2->length, NULL, NULL);
+                                    rs->chunk->used += rs2->length;
+                                } else {
+                                    space_list_add2(rs2->list, rs2->list_size, rs2->address, rs2->length, NULL, NULL);
+                                    rs->chunk->used -= rs2->length;
+                                }
+
                                 ExFreePool(rs2);
                                 RemoveEntryList(&ri2->list_entry);
                                 ExFreePool(ri2);
                             }
                         }
-                        
+
                         le2 = le3;
                     }
-                    
+
                     ExReleaseResourceLite(&rs->chunk->lock);
                 }
-                    
+
                 ExFreePool(rs);
-                
+
                 break;
             }
         }
-        
+
         ExFreePool(ri);
     }
 }
@@ -1218,26 +1153,26 @@
 
 static void find_tree_end(tree* t, KEY* tree_end, BOOL* no_end) {
     tree* p;
-    
+
     p = t;
     do {
         tree_data* pi;
-        
+
         if (!p->parent) {
             *no_end = TRUE;
             return;
         }
-        
+
         pi = p->paritem;
-        
+
         if (pi->list_entry.Flink != &p->parent->itemlist) {
             tree_data* td = CONTAINING_RECORD(pi->list_entry.Flink, tree_data, list_entry);
-            
+
             *tree_end = td->key;
             *no_end = FALSE;
             return;
         }
-        
+
         p = p->parent;
     } while (p);
 }
@@ -1246,14 +1181,14 @@
     while (!IsListEmpty(batchlist)) {
         LIST_ENTRY* le = RemoveHeadList(batchlist);
         batch_root* br = CONTAINING_RECORD(le, batch_root, list_entry);
-        
+
         while (!IsListEmpty(&br->items)) {
             LIST_ENTRY* le2 = RemoveHeadList(&br->items);
             batch_item* bi = CONTAINING_RECORD(le2, batch_item, list_entry);
-            
+
             ExFreeToPagedLookasideList(&Vcb->batch_item_lookaside, bi);
         }
-        
+
         ExFreePool(br);
     }
 }
@@ -1263,26 +1198,27 @@
     LIST_ENTRY* le;
     INODE_REF* delir = (INODE_REF*)bi->data;
     INODE_EXTREF* ier;
-    
+
     TRACE("entry in INODE_REF not found, adding Batch_DeleteInodeExtRef entry\n");
-    
+
     bi2 = ExAllocateFromPagedLookasideList(&Vcb->batch_item_lookaside);
     if (!bi2) {
         ERR("out of memory\n");
         return;
     }
-    
+
     ier = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_EXTREF) - 1 + delir->n, ALLOC_TAG);
     if (!ier) {
         ERR("out of memory\n");
+        ExFreePool(bi2);
         return;
     }
-    
+
     ier->dir = bi->key.offset;
     ier->index = delir->index;
     ier->n = delir->n;
     RtlCopyMemory(ier->name, delir->name, delir->n);
-    
+
     bi2->key.obj_id = bi->key.obj_id;
     bi2->key.obj_type = TYPE_INODE_EXTREF;
     bi2->key.offset = calc_crc32c((UINT32)bi->key.offset, (UINT8*)ier->name, ier->n);
@@ -1289,28 +1225,28 @@
     bi2->data = ier;
     bi2->datalen = sizeof(INODE_EXTREF) - 1 + ier->n;
     bi2->operation = Batch_DeleteInodeExtRef;
-    
+
     le = bi->list_entry.Flink;
     while (le != listhead) {
         batch_item* bi3 = CONTAINING_RECORD(le, batch_item, list_entry);
-        
+
         if (keycmp(bi3->key, bi2->key) != -1) {
             InsertHeadList(le->Blink, &bi2->list_entry);
             return;
         }
-        
+
         le = le->Flink;
     }
-    
+
     InsertTailList(listhead, &bi2->list_entry);
 }
 
-static BOOL handle_batch_collision(device_extension* Vcb, batch_item* bi, tree* t, tree_data* td, tree_data* newtd, LIST_ENTRY* listhead, LIST_ENTRY* rollback) {
+static NTSTATUS handle_batch_collision(device_extension* Vcb, batch_item* bi, tree* t, tree_data* td, tree_data* newtd, LIST_ENTRY* listhead, BOOL* ignore) {
     if (bi->operation == Batch_Delete || bi->operation == Batch_SetXattr || bi->operation == Batch_DirItem || bi->operation == Batch_InodeRef ||
         bi->operation == Batch_InodeExtRef || bi->operation == Batch_DeleteDirItem || bi->operation == Batch_DeleteInodeRef ||
-        bi->operation == Batch_DeleteInodeExtRef) {
-        UINT16 maxlen = Vcb->superblock.node_size - sizeof(tree_header) - sizeof(leaf_node);
-        
+        bi->operation == Batch_DeleteInodeExtRef || bi->operation == Batch_DeleteXattr) {
+        UINT16 maxlen = (UINT16)(Vcb->superblock.node_size - sizeof(tree_header) - sizeof(leaf_node));
+
         switch (bi->operation) {
             case Batch_SetXattr: {
                 if (td->size < sizeof(DIR_ITEM)) {
@@ -1320,71 +1256,70 @@
                     ULONG size = td->size;
                     DIR_ITEM* newxa = (DIR_ITEM*)bi->data;
                     DIR_ITEM* xa = (DIR_ITEM*)td->data;
-                    
+
                     while (TRUE) {
                         ULONG oldxasize;
-                        
+
                         if (size < sizeof(DIR_ITEM) || size < sizeof(DIR_ITEM) - 1 + xa->m + xa->n) {
                             ERR("(%llx,%x,%llx) was truncated\n", bi->key.obj_id, bi->key.obj_type, bi->key.offset);
                             break;
                         }
-                        
+
                         oldxasize = sizeof(DIR_ITEM) - 1 + xa->m + xa->n;
-                        
+
                         if (xa->n == newxa->n && RtlCompareMemory(newxa->name, xa->name, xa->n) == xa->n) {
                             UINT64 pos;
-                            
+
                             // replace
-                            
+
                             if (td->size + bi->datalen - oldxasize > maxlen)
                                 ERR("DIR_ITEM would be over maximum size, truncating (%u + %u - %u > %u)\n", td->size, bi->datalen, oldxasize, maxlen);
-                            
+
                             newdata = ExAllocatePoolWithTag(PagedPool, td->size + bi->datalen - oldxasize, ALLOC_TAG);
                             if (!newdata) {
                                 ERR("out of memory\n");
-                                return TRUE;
+                                return STATUS_INSUFFICIENT_RESOURCES;
                             }
-                            
+
                             pos = (UINT8*)xa - td->data;
-                            if (pos + oldxasize < td->size) { // copy after changed xattr
-                                RtlCopyMemory(newdata + pos + bi->datalen, td->data + pos + oldxasize, td->size - pos - oldxasize);
-                            }
-                            
+                            if (pos + oldxasize < td->size) // copy after changed xattr
+                                RtlCopyMemory(newdata + pos + bi->datalen, td->data + pos + oldxasize, (ULONG)(td->size - pos - oldxasize));
+
                             if (pos > 0) { // copy before changed xattr
-                                RtlCopyMemory(newdata, td->data, pos);
+                                RtlCopyMemory(newdata, td->data, (ULONG)pos);
                                 xa = (DIR_ITEM*)(newdata + pos);
                             } else
                                 xa = (DIR_ITEM*)newdata;
-                            
+
                             RtlCopyMemory(xa, bi->data, bi->datalen);
-                            
-                            bi->datalen = min(td->size + bi->datalen - oldxasize, maxlen);
-                            
+
+                            bi->datalen = (UINT16)min(td->size + bi->datalen - oldxasize, maxlen);
+
                             ExFreePool(bi->data);
                             bi->data = newdata;
-                            
+
                             break;
                         }
-                        
+
                         if ((UINT8*)xa - (UINT8*)td->data + oldxasize >= size) {
                             // not found, add to end of data
-                            
+
                             if (td->size + bi->datalen > maxlen)
                                 ERR("DIR_ITEM would be over maximum size, truncating (%u + %u > %u)\n", td->size, bi->datalen, maxlen);
-                            
+
                             newdata = ExAllocatePoolWithTag(PagedPool, td->size + bi->datalen, ALLOC_TAG);
                             if (!newdata) {
                                 ERR("out of memory\n");
-                                return TRUE;
+                                return STATUS_INSUFFICIENT_RESOURCES;
                             }
-                            
+
                             RtlCopyMemory(newdata, td->data, td->size);
-                            
+
                             xa = (DIR_ITEM*)((UINT8*)newdata + td->size);
                             RtlCopyMemory(xa, bi->data, bi->datalen);
-                            
+
                             bi->datalen = min(bi->datalen + td->size, maxlen);
-                            
+
                             ExFreePool(bi->data);
                             bi->data = newdata;
 
